package org.cn3.morpho.domain;

import java.io.File;

/**
 * 
 * @author gillette
 *
 * Basic metadata based on NMO and neuron arbor.
 *
 */
public class NeuronMetadata implements Comparable<NeuronMetadata>{
	
	public static final int ARBOR_TYPE_AXON = 1;
	public static final int ARBOR_TYPE_DENDRITE = 2;
	public static final int ARBOR_TYPE_BASAL = 3;
	public static final int ARBOR_TYPE_APICAL = 4;

	public static final String[] ARBOR_TYPE_STRINGS = {"","Axon","Dendrite","BasalDendrite","ApicalDendrite"};

	private int id;
	protected String name;
	protected String animal;
	protected String brainRegion;
	protected String cellType;
	protected String labName;
	
	//private Soma<T> soma;

	private File swcFile;
	
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}

	public String getSpecies() {
		return animal;
	}
	public void setSpecies(String animal) {
		this.animal = animal;
	}
	public String getAnimal() {
		return animal;
	}
	public void setAnimal(String animal) {
		this.animal = animal;
	}
	public String getBrainRegion() {
		return brainRegion;
	}
	public void setBrainRegion(String brainRegion) {
		this.brainRegion = brainRegion;
	}
	public String getCellType() {
		return cellType;
	}
	public void setCellType(String cellType) {
		this.cellType = cellType;
	}
	public File getSwcFile() {
		return swcFile;
	}
	public void setSwcFile(File swcFile) {
		this.swcFile = swcFile;
	}
	public String getArchive() {
		return labName;
	}
	public void setArchive(String archive) {
		this.labName = archive;
	}
	public String getLabName() {
		return labName;
	}
	public void setLabName(String labName) {
		this.labName = labName;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	/*
	public Soma<T> getSoma() {
		return soma;
	}
	public void setSoma(Soma<T> soma) {
		this.soma = soma;
	}
	*/
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append(name);
		sb.append(" / ");
		sb.append(cellType);
		sb.append(" / ");
		sb.append(brainRegion);
		sb.append(" / ");
		sb.append(animal);
		sb.append(" / ");
		sb.append(labName);
		return sb.toString();
	}

	public int compareTo(NeuronMetadata neuron){
		if (neuron == null){
			return 1;
		}
		if (name == null){
			return (neuron.getName() == null ? 0 : -1);
		}
		if (neuron.getName() == null){
			return 1;
		}
		return name.compareTo(neuron.getName());
	}
	
}
