package org.cn3.morpho.utils;

import java.math.BigInteger;

public class MathUtils {

	public static BigInteger factorial(int number){
		return new BigInteger(""+number).multiply(factorial(number-1));
	}
	public static BigInteger choose(int n, int r){
		if (r == n){
			return BigInteger.ONE;
		}
		if (r > n){
			return BigInteger.ZERO;
		}
		int r2 = n-r;
		if (r2 < r){
			r = r2;
		}
		BigInteger ret = BigInteger.ONE;
	    for (int k = 0; k < r; k++) {
	        ret = ret.multiply(BigInteger.valueOf(n-k))
	                 .divide(BigInteger.valueOf(k+1));
	    }
	    return ret;
	}
	
	public static double pFromE(double E){
		return 1-Math.exp(-E);
	}
	public static double EFromP(double p){
		return -Math.log(1-p);
	}
}
