package org.cn3.ns.domain;

import java.util.LinkedHashMap;
import java.util.Map;

public class SimpleDBDistBean {

	protected int id;
	protected float total = 0;
	protected int count = 0;
	protected double mean = 0;
	protected float standardDeviation = 0;
	protected float standardError = 0;
	
	private int sequenceId;
	private int queryLength;

	// percentile and related value
	protected Map percentileMap = new LinkedHashMap(5);

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public double getMean() {
		return mean;
	}

	public void setMean(double mean) {
		this.mean = mean;
	}

	public Map getPercentileMap() {
		return percentileMap;
	}

	public void setPercentileMap(Map percentileMap) {
		this.percentileMap = percentileMap;
	}

	public double getStandardDeviation() {
		return standardDeviation;
	}

	public void setStandardDeviation(float standardDeviation) {
		this.standardDeviation = standardDeviation;
	}

	public double getStandardError() {
		return standardError;
	}

	public void setStandardError(float standardError) {
		this.standardError = standardError;
	}

	public float getTotal() {
		return total;
	}

	public void setTotal(float total) {
		this.total = total;
	}

	public double getVariance() {
		return standardDeviation*standardDeviation;
	}

	public void setVariance(float variance) {
		standardDeviation = (float)Math.sqrt(variance);
	}

	public int getQueryLength() {
		return queryLength;
	}

	public void setQueryLength(int queryLength) {
		this.queryLength = queryLength;
	}

	public int getSequenceId() {
		return sequenceId;
	}

	public void setSequenceId(int sequenceId) {
		this.sequenceId = sequenceId;
	}

	public void setPercentile(double percentile, float value) {
		if (percentile >= 1 && percentile < 100){
			percentile = percentile / 100;
		}
		percentileMap.put(new Float(percentile), new Float(value));
	}

	// Common percentiles
	public float get50thPercentile(){
		return getPercentile((float).5);
	}
	public float get95thPercentile(){
		return getPercentile((float).95);
	}
	public float get99thPercentile(){
		return getPercentile((float).99);
	}

	public float getPercentile(float percentile){
		if (percentile >= 1 && percentile < 100){
			percentile = percentile / 100;
		}
		Float percentileObj = new Float(percentile);
		if (percentileMap.containsKey(percentileObj)){
			return ((Float)percentileMap.get(percentileObj)).floatValue();
		}
		return 0;
	}
}
