package org.cn3.ns.nodeencoding;

import org.cn3.morpho.domain.BinaryTreeNode;
import org.cn3.morpho.domain.SwcDataNode;

public class JoinedTreeTopo1Encoder extends NodeEncoder {

	public JoinedTreeTopo1Encoder(){
		setEncodingMode(EncodingMode.TOPO_GACT);
	}

	public String encodeNode(BinaryTreeNode node) throws Exception{
		if (node.getLeft() != null && node.getRight() != null){
			SwcDataNode data = (SwcDataNode)node.getData();
			if (data.getType() == 0){
    			return "G";
    		}
    		else if (node.getLeft().hasChildren() && node.getRight().hasChildren()){
				return "A";
			}
			else if (node.getLeft().hasChildren() ^ node.getRight().hasChildren()){
				return "C";
			}
			else{
				return "T";
			}
		}
		return "";
	}

	public BinaryTreeNode decodeChar(char character, BinaryTreeNode node){
		node.setRight(new BinaryTreeNode());
		node.setLeft(new BinaryTreeNode());

		switch(character){
		case 'A':
		case 'G':
			node.setData("A");
			node = node.getLeft();
			break;
		case 'C':
			node.setData("C");
			node = node.getLeft();
			break;
		case 'T':
			node.setData("T");
			boolean done = false;
			while (node.getParent() != null && !done){
				if (node.getParent().getData().equals("C") || node.isRight()){
					node = node.getParent();
				}
				else if (node.isLeft()){
					node = node.getParent().getRight();
					done = true;
				}
			}
			break;
		}
		return node;
	}
	
}
