package org.cn3.ns.nodeencoding;

import org.cn3.morpho.domain.BinaryTreeNode;

public class Topological0thOrderEncoder extends NodeEncoder {

	public Topological0thOrderEncoder(){
		setEncodingMode(EncodingMode.TOPO_ZERO);
	}

	public String encodeNode(BinaryTreeNode node) throws Exception{
		if (node.hasChildren()){
			return "A";
		}
		else{
			return "T";
		}
	}
	
	public BinaryTreeNode decodeChar(char character, BinaryTreeNode node){
		switch(character){
		case 'A':
			node.setData("A");
			node.setRight(new BinaryTreeNode());
			node.setLeft(new BinaryTreeNode());
			node = node.getLeft();
			break;
		case 'T':
			node.setData("T");
			boolean done = false;
			while (node.getParent() != null && !done){
				if (node.isRight()){
					node = node.getParent();
				}
				else if (node.isLeft()){
					node = node.getParent().getRight();
					done = true;
				}
			}
			break;
		}
		return node;
	}
	
}
