package org.cn3.ns.resources;

import org.cn3.morpho.data.NeuronTreeClassification;
import org.cn3.ns.nodeencoding.EncodingMode;



public interface NSConstants {

	public final static String BLAST_RESULTS_LOCATION = "blast.results.dir";
	public final static String BLAST_LOCATION = "blast.dir";
	public final static String BLAST_DATA_LOCATION = "blast.data.dir";
	public final static String CLUSTALO_LOCATION = "clustalo.dir";
	//public final static String PROPERTIES_FILE = "blastMorpho.properties";
	public final static String DATA_PROPERTIES_FILE = "conf/data.properties";
	
	public final static String FLAGGED_NEURONS_FILE = "flaggedNeurons";
	
	public final static String SWC_LOCATION = "swc.dir";
	public final static String FASTA_LOCATION = "fasta.dir";
	public final static String FASTA_RANDOMS_LOCATION = "fasta.randoms.dir";
	public final static String RESULTS_LOCATION = "results.dir";
	public final static String RESULTS_LOOKUP_LOCATION = "results.lookup.dir";
	
	public final static String WORKING_LOC = "workingDir";
	public final static String RESOURCES_LOC = "data.resources";
	public final static String DATASOURCE = "datasource";
	public final static String META_DATABASE_FILENAME = "data.metadata";
	public final static String LENGTH_DATABASE = "data.lengths";
	
	// Useful when attempting to sample constrained surrogates truly uniformly
	public final static String OUTLIERS = "data.outliers";
	public final static String OUTLIERS_ALL_TREE = "data.allTreeOutliers";
	public final static String DIMER_TOO_UNLIKELY = "data.dimer.tooUnlikely";
	public final static String TRIMER_TOO_UNLIKELY = "data.trimer.tooUnlikely";
		
	public final static String DATABASE_TYPE_CELL = "cell";
	public final static String DATABASE_TYPE_ARBORIZATION = "arborization";
	public final static String DATABASE_TYPE_TREE = "tree";
	
	public final static String SUB_WORD_LENGTH_SCORE = "missedBitScore.";
	public final static String USE_ADJUSTED_PREFIX = "useAdjusted.";
	
	public final static String NEUROMORPHO_SEQUENCE = "neuromorpho.sequence";
	
	public final static String GEOMETRY_MEDIAN_LENGTH = "geometry.length.median";
	public final static String GEOMETRY_MEDIAN_ANGLE = "geometry.angle.median";
	
	public final static int DISTRIBUTION_NEUROMORPHO = 0;
	public final static int DISTRIBUTION_SEQUENCE_GROWTH = 1;
	public final static int DISTRIBUTION_TERMINAL_GROWTH = 2;
	public final static int DISTRIBUTION_UNIFORM = 3;
	public final static int DISTRIBUTION_NM_RAND_SEQUENCE = 4;
	public final static int DISTRIBUTION_RESIDUE_FREQ_CONSTRAINED = 5; // Monomer constrained
	public final static int DISTRIBUTION_NM_RAND_SEQUENCE2 = 6;
	public final static int DISTRIBUTION_NODE_TYPE_ASSEMBLED2 = 7; // Up to dimer constrained
	public final static int DISTRIBUTION_NODE_TYPE_ASSEMBLED3 = 8; // Up to 4-mer constrained
	public final static int DISTRIBUTION_INTERSTITIAL_GROWTH = 9; // Trimer constrained
	// NODE_TYPE_ASSEMBLED4: Up to 4-mer constrained, without composite k-mers; see NodeSequenceBinaryTreeGenerator.detectComposites()
	public final static int DISTRIBUTION_NODE_TYPE_ASSEMBLED4 = 11;  
	public final static int DISTRIBUTION_RANDOM_SEQUENCE = 10;
	public final static int RANDOM_SEQUENCE_GROWTH = DISTRIBUTION_SEQUENCE_GROWTH;
	public final static int RANDOM_TERMINAL_GROWTH = DISTRIBUTION_TERMINAL_GROWTH;
	public final static int RANDOM_UNIFORM_DIST = DISTRIBUTION_UNIFORM;
	
	public final static String PARAM_MAPPING_MODE = "mapping";
	public final static String PARAM_TRAVERSAL = "traversal";
	public final static String PARAM_ORDER = "order";
	public static final String PARAM_SOURCE_TRAVERSAL = "sourceTraversal";
	public final static String PARAM_BASELINE = "baseline";
	public final static String PARAM_RANDOM_METHOD = "method";
	public final static String PARAM_BASELINE_ADJUSTED = "use-adjusted"; // Was used for stat baseline, but no longer
	public final static String PARAM_REWARD = "reward";
	public final static String PARAM_MISMATCH = "mismatch";
	public final static String PARAM_GAP_OPEN = "gap-open";
	public final static String PARAM_GAP_EXTEND = "gap-extend";
	public final static String PARAM_EVAL = "e-value";
	public final static String PARAM_WORD_SIZE = "word-size";
	public final static String PARAM_BLASTP = "blastp";
	public final static String PARAM_SCORE_MATRIX = "score-matrix";
	public final static String PARAM_BASELINE_RUNS = "baseline-runs";
	public final static String PARAM_DATASET = "dataset";
	public final static String PARAM_LENGTH_CONSIDERED = "length-considered";
	public static final String PARAM_CLASSIFICATION = "classification";

	public static final String CLASSIFICATION_CELL = "Cell";
	public static final String CLASSIFICATION_ARBORIZATION = "Arborization";
	public static final String CLASSIFICATION_TREE = "Tree";

	public final static String PARAM_DEBUG = "debug";
	public final static String PARAM_TRACE = "trace";

	public final static String DEFAULT_DATASET = "NM";
	
	/*
	 * Plans to transfer mapping mode constants into enum MappingMode in the same package that contains NSConstants.
	 */
	public final static int MAPPING_MODES = 7;
	// Zero order topology
	public final static int MAPPING_MODE_TOPO_CA = 1;
	public final static int MAPPING_MODE_TOPO_ZERO = 1;
	// First order topology
	public final static int MAPPING_MODE_TOPO_ACT = 2;
	public final static int MAPPING_MODE_TOPO_ONE = 2;
	// First order topo with length to branch and angle of bifurcation relative to median
	public final static int MAPPING_MODE_TOPO_LEN_ANG = 3; 
	// First order topo with joined dendrite nodes as G
	public final static int MAPPING_MODE_TOPO_GACT = 4;
	// First order topo with length to branch and angle of bifurcation relative to parent
	public final static int MAPPING_MODE_TOPO_LOCAL_LEN_ANG = 5;
	// Separate character for first order topo, length to branch, and angle of bifurcation (LTB,AOB relative to parent) 
	public final static int MAPPING_MODE_TOPO_LTB_AOB_SEPARATE = 6;
	// Second order topology
	public final static int MAPPING_MODE_TOPO_TWO = 7;
	
	public final static int DEFAULT_MAPPING_MODE = MAPPING_MODE_TOPO_ACT;
	public final static EncodingMode DEFAULT_MAPPING = EncodingMode.TOPO_ONE;

	public final static int[] SEQUENCE_TYPES = {1,2,3};
	public final static int SEQUENCE_TOPOLOGY_ZERO = 1;
	public final static int SEQUENCE_TOPOLOGY_ONE = 2;
	public final static int SEQUENCE_TOPOLOGY_TWO = 3;
	
	/**
	 *  Affects length of sequence based on tree
	 *  Up to mapping 7, all "no terms" are second order, but a second
	 *  order mapping could exist that includes terminations for geometric
	 *  data encoding.
	 */
	public final static int[] mappingModeSequenceType = {0,
		SEQUENCE_TOPOLOGY_ZERO,
		SEQUENCE_TOPOLOGY_ONE,
		SEQUENCE_TOPOLOGY_ONE,
		SEQUENCE_TOPOLOGY_ONE,
		SEQUENCE_TOPOLOGY_ONE,
		SEQUENCE_TOPOLOGY_ONE,
		SEQUENCE_TOPOLOGY_TWO};
	
	public final static boolean[] mappingModeBlastP = {false,
		false,
		true,
		true,
		true,
		true,
		true,
		true};

	public final static int DEFAULT_BASELINE = DISTRIBUTION_UNIFORM;
	public final static int DEFAULT_BASELINE_RUNS = 100;
	
	public final static boolean DEFAULT_BLASTP = true;
	public final static int DEFAULT_REWARD = 1;
	public final static int DEFAULT_MISMATCH = -2;
	public final static int DEFAULT_GAP_EXISTENCE = 1;
	public final static int DEFAULT_GAP_EXTENSION = 1;
	public final static int DEFAULT_P_GAP_EXISTENCE = 6;
	public final static int DEFAULT_P_GAP_EXTENSION = 2;
	public final static int DEFAULT_WORD_LENGTH = 2;
	public final static String DEFAULT_SCORE_MATRIX = "local";
	
	public final static String DEFAULT_BLAST_PARAM_STRING = "R1Q-2G1E1";
	public final static String DEFAULT_TRAVERSAL = "Size";
	public final static String DEFAULT_ORDER = "STL";
	//public final static String DEFAULT_CLASSIFICATION = NSConstants.CLASSIFICATION_ARBORIZATION;
	public final static NeuronTreeClassification DEFAULT_CLASSIFICATION = NeuronTreeClassification.SUB_ARBORIZATION;

}
