package org.cn3.ns.scripts;

import java.io.File;
import java.util.Map;
import java.util.TreeMap;

import org.cn3.morpho.data.SwcToNewick;
import org.cn3.morpho.utils.StringUtils;
import org.cn3.ns.data.SwcACTWriter;
import org.cn3.ns.resources.DataProperties;

import com.martiansoftware.jsap.FlaggedOption;
import com.martiansoftware.jsap.JSAP;
import com.martiansoftware.jsap.JSAPResult;
import com.martiansoftware.jsap.Switch;

/**
 * 
 * @author gillette
 * 
 * Currently just a script with hard-coded alignments.
 * Possible future version with parameters to run one at a time.
 * 
 * java -classpath .:lib/JSAP-2.1.jar org.cn3.ns.scripts.ColorNeuriteByGlobalAlignment
 *
 */
public class ColorNeuriteByGlobalAlignment {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try{
			
	//		JSAPResult config = readParameters(args);
			/*
			String domainFile = args[1];
			String queryName = args[2];
			String domain = args[3];

			// Traverse domain file to extract alignment information
			*/
			File swcFile, outputDir;
			int startPos = 1;
			
			String neuronName, neuriteAlignment, 
				consensusAlignNoExcess, neuriteAlignNoExcess;
			String[] ungappedSeqs;
			Map<String,String> neurites;

//			String consensusName = "AxonCluster4ForFig5a";
//			String consensusWithGaps = "-----------------------------------------------------------------A--------------------------C-----T---A---------------------------------------------A----------C-T---------C-----A---T--C-T-------------------A----------------C---CT----------------------A----------A----T-C-C-T--------------A----------CT-----------------A------CT---C--------C---T";
//
//			outputDir = new File("/home/tgillett/figures/Pasta2/");
//			neurites = new TreeMap<String,String>();
//			neurites.put("AWa020209-Axon","-----A--A--------C-T--------C----C-----T-------------------------A-A-T-ACCTAACCTCC-TC-----ATA-TCCCT---A---C------------------A---------A-T-A-T-TA-TCA----------C-T--C------ACCCT-A-C-T--ATTA--------TC--A--T--A--CA---T-C--C-C-A-TCCT----------------------A-A--CT----A---CT-C-C-T-C------------A-------AT--T-----------------A-------T---A--T-----C---T");
//			neurites.put("OFD8L-Axon","-----C-----------------------------------------------------------C------------------------------------A----------------------C----------------------A----------C-T--A----T-A--CTCC----CCC-T-------------------A----------------C---CT----------------------A-A---T----A----T-C-C-T--------------C-----------------------------A------CT---A--T---------T");
//			neurites.put("AK123-Axon","-----A----------------------C----C-----T-------------------------A--------------------------C-----T---A---------------------------------------------A------------T------------------------T-------------------A--------------------CT----------------------A-C--------A----T-----T--------------A-----------T-----------------A-------T---C------------T");
//			neurites.put("TS091908s1cell2-Axon","-----C-----------------------------------------------------------A---------A-----C-TA--TATC-A-T--CTC--A---A---------T--------A-----------------T----A--------ATC-T--AA-T-T-C----CA---T--C-T-------------------A---C------------C---CT----------------------A-C--------C-----CC-C-T--------------A-------AT--T-----------------A--C---CT---A--T-----C---T");
//			neurites.put("570mg-2-1-3-Axon","-----------------------------------------------------------------C------------------------------------A----------------------C----------------------A------------T---------------A---T----T-------------------A--------------------CT----------------------A----------C--------C-T--------------A-----------T-----------------C-----------C------------T");
//			neurites.put("005-cyan1-Axon","-----------------------------------------------------------------A---------C----------------A-T--CT---A---------------------------------------------C----------------------------C--------T-------------------A--------------------CT----A--------T--------A----------A----T-C-C-T--------------A-----------T-----------C-----C-----------C--------C---T");
//			neurites.put("040728TTX-Axon","-----------------------------------------------------------------A--------------------------C-----T---A----------------------C----------------------A----------C-T---------------A---T----T----------------------------------------------------------------A----------C------C-C-T-C------------A-----------T-----------------A------CT---C--------C--CT");
//			neurites.put("py-160706-Axon","-----------------------------------------------------------------A---------A-----C-T------C-C----CT---A---------------------------------------------A--------C-ATT---------A--CTCA---T--C-T-------------------A---------------------T----------------------A-C--------AAT--TCC-C-T--------------A-------C--CT-----------C-----A--C---CT---C--------A-T-T");
//			neurites.put("No9-Veh-Axon","-----------------------------------------------------------------C------------------------------------A---------------------------------------------A--------C-C-T---------C-----C--------T-------------C-----A---------------------TC---A--------T--------A----------A----T---C-T--------------A----------CT-----------------A------CT---C--------C---T");
//			neurites.put("AP121509Dcell2-Axon","-----------------------------------------------------------------A--------------------------------T---A----------------------C----------------------A------C-C-C-T--C------C-----A-C-TCCATT-------------------A---------------------T----C-----------------A----------A----T-C-C-T--------------A----------CT-----------------A------CT--CA--T-----C--CT");
//			neurites.put("070517-exp3-zB-Axon","-----------------------------------------------------------------A---------C----------------A-T---T---A---------------------------------------------A--------C-C-T--C------C-----C------C-T-------------C-----A--------------------CT----------------------A----------C----------T--------------C-----------------------------A--A-T--T---A--T-----C---T");
//			neurites.put("PRC2071122AM-Axon","-----------------------------------------------------------------A---------AA--TCATTA-CT--C-C----CT---A---------------------------------------------A--------ATC-T---------A---T-A---T----TA---ACTCCT---A-CT--A---ACC-T--------C---CT----A-----C--T--------A----------A----T---C-T-A-----C-CT---A-------C--CTATACTA-C-TCA-CATTA--A-T-CT---A-CT---ATACTCT");

			
//			String consensusName = "AxonCluster4ForFig5-T35";
//			String consensusWithGaps = "--------------------------------------------------------------------------------------------------A---------------------------C------------------------C-----CT----A-------------------------------------------A----------C-T--C------C-----A---T--C-T----------------------------A----C-------------C-----CT---------------------------------------------A------------A----T-C-C-T---------------A----------CT----------------C--------A-----C-T----A--T---C--C---T";

//			String consensusName = "AxonCluster4ForFig5-T65";
//			String consensusWithGaps = "--------------------------------------------------------------------------------------------------C----------------------------------------------------------------A-------------------------------------------A----------C-T---------------C------C-T----------------------------A------------------------CT---------------------------------------------A------------C--------C-T---------------A-----------T-------------------------A-------T----C---------C---T";
//
//			outputDir = new File("/home/tgillett/figures/Pasta2/");
//			neurites = new TreeMap<String,String>();
//			// RatPyramidal
//			neurites.put("I03464-Axon","--------------------------------------------------------------------------------------------------A---------------------------C------------------------A-T---CT----A-------------------------------------------A----------C-T---------------A---T--C-T----------------------------A----A--C-T--------A-T---CT---------------------------------------------A------------C----------T---------------A----------CT----------------A----T---A-A-T-C-T----A-CT------A-T-T");
//			neurites.put("g0758_b-Axon","--------------------------------------------------------------------------------------------------C----------------------------------------------------------------A-------------------------------------------A--------C-C-T--C------C-----A---T----T---C------------------------A----C-------------ACT---CT-------A-----------T-------------------------A------------C----------T---------------A----------CT----------------C--------A-----C-TC---A--T---C--C---T");
//			neurites.put("C200897C-P4-Axon","----------A---------C-----------------------------C--------C-----CCT------------------------------A----------------------------------------------------A-T---CT----A-------------------------------------------A----------C-T---------------C--------T----------------------------A------------------C-----CT---------------------------------------------A------C-----AAT--T-C-C-T---------------A-----------T----------------C--------A-------T----C------C--C---T");
//			neurites.put("C180298A-P2-Axon","--------------------------------------------------------------------------------------------------A---------------------------A-----------T------C-----A-T---CT----A-------------------------------------------A------C-C-ATT--C------C-----C-----CC-T----------------------------A--C-A--C-T--------C-----CT---------------------------------------------A------------C--------C-T---------------A----C-----CT-------------------------A-------T----C---------C---T");
//			// Non-RatPyramidal
//			neurites.put("n254-Axon",  "-------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------A-----------------T---A--------C-ATT--C------C-----A-C-T--C-T---C-----------------C------A------------------------CT---------------------------------------------A------------A----T-C-C-T---------------A----------CT-------------------------A-C---C-T----C---------A-T-T");
//			neurites.put("070318-exp4-zA-Axon","--------------------------------------------------------------------------------------------------C----------------------------------------------------------------A---------------------C--------------------CA------------T--C------------C------C-T----------------------------AC-ATA--C-T--------A-T---CT---------------------------------------------A------ACT---A----T-C-C-T---------------A----C-----CT-------------------------A-----C-T----A--T------C---T");
//			neurites.put("070318-exp4-zA-Axon","--------------------------------------------------------------------------------------------------C----------------------------------------------------------------A---------------------C--------------------CA------------T--C------------C------C-T----------------------------AC-ATA--C-T--------A-T---CT---------------------------------------------A------ACT---A----T-C-C-T---------------A----C-----CT-------------------------A-----C-T----A--T------C---T");
//			//neurites.put("BC-2011-07-08-B-L6B-dendax-Axon","");
//			//neurites.put("AWab042309cell2-Axon","");

			
//			String consensusName = "AxonCluster1ForFig5-T50";
//			String consensusWithGaps = "----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------T----------------A-------------------------------------------------------------------C-----------------C--C------T--------------------------------------------A---------------------------------------------C---T-------------------------------------------------------------C--------------------------------------C--------------------------------C------------C----T-------------------------------------------------------------------------------------------A------------------------------------------------------------------------------------------------------------------------------------C-----------------------------------------------------------------------------------------------A----------------------------------T--------------------C--------------------------C-T----------------------------------------------------------------------------------------------------A----------------------------------------------------------------------------------------------------------------------------------A-----------C-----T---------C--------------A-----T------C----C--T--------------------------A---------------------------------------------C------------------------C----------C-T------------------------------------C----------------------------------------------------------------A--------------------------------------------------C------C---T-------------A----------------------------T---------------------A--------------T-------C---------C---------C-------CT";
//
//			outputDir = new File("/home/tgillett/figures/Pasta2/");
//			neurites = new TreeMap<String,String>();
//			neurites.put("C290500C-I4-Axon","-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------C------------------------------C--A------------------T-A---------T-C--------C--C------C-C-C----CCC--CT-----------A-------------------A----------CT-A--------------------------------------C----------------------------------------------------------------------------------------------C-------------------------------------C----T----------------A----A-----------T-----C-C------------------A------------T--C-----C-A----C---CT-------C--C---CCCT-----------A--CT---A-------C-------C--T-----A---------------A-------------CT--------------C--CT-----------C----C---A---------------------------------CT-----A-------------------------------CT-----A-------------------T-C---C--CC--C-------C-C--C--CCT-------------------------------------------------------------------------------------------A------------------------------------------------------------------------------------------------------------------------------------A------------------------------------------C-----A----T--A-TCT----------------------------------C-------------------------------------------------------C-----------A---T----------ATT---A-------------------------------------------------------------C-------C----CT--------------------A----------------------------------------------------------------------------------------------------------------------------------A-----------------T---------A----------T---C-------C----AC-T-C--T------C-------------------A---------------------------------------------------------------------------------C-T------------------------------------A----------------------------------------T----------A-----------TA---------------------------------------------------------C---T-------------A----------------------------T----C------------C---A---CC----CCC-CT-------A---CATT--C---------C-------CT");
//			neurites.put("MJ042605-1-Axon","----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A-------------------C-------------A-------------C------------------------A-------------------------------T--------------------C-----------------------------------------C---------------------------C---------C---CT----------------A-------------------------------------------C---------------C-------A----C----T-------C--C-----CT--------------------------------------------A---------------C-----------------------------C---T-------------------------------------------------------------C--------------------------------------A-------------------T------------C------------C----T--A----------------------------------------------A-------T---------------------CC---C--T---A------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A--------------------------------C-T--------------------C---------------------C----C-T---A-------------------------------------------A-------C--T--------------C----CT--------------------A----------------------------------------------------------------------------C-----------------------------------------------------A-----------C----CT---------C--------------A-----T-C----C----C--T--------------------------A---C----------------C----C-----------------C-A--------------T---------A--T------CC-T------------------------------------A----------------------------C-----C---C-T-----------------------A-----------------AT--A------ACT-CC-CT-----C-------ACCT---C--CT-------------A-----------------C---------CT---------------------A---CC----CCC-CT-------C---------A--CC-T---C-------CT");

//			neurites.put("C290500B-I3-Axon","-----------------------------------------------------------A---------------------------------------------------------------------------------------------------------------------------------------------------T---------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A----------A--T--T---C------C--C--A------------------T----------------------C--C--------C-C-----CC--CT-----------A---------------------------------A--------------------------------------A-----------------------------C-T--------------------------------------------------------------A---------CT----------------C---------C----TCC---A--------CTA-------------------------------------------------------------------C--------------------C------T-------------------C------------------------A---------------C----------------------C------A-T-T--------------------A----------------------------------T-----C---------------------------------C----A-------------------T--------CC--C---------C--C---CT-------------------------------------------------------------------------------------------A-------------------A-------------------------C-----------------------------A--T----T------------------------------------------------A------------------------------------------------------------T----------------------------------A-------------------------C--C---C-T--------------------A------TA-T-AC-CT-----C----C-T---C------------------------------------------------------------------------------------------------A----------------------------------------------------------------------------------------------------------------------------------A----C-----CC---CCT------------------------A-----T-C----A--T-C--T------C-------------------A---------------------------------------------------------------------------------C-T------------------------------------A----------------------------------------T-----------------------A--------------------------------------------------C------A-T-T-----C--C---CA----------------------------T----C------------A--TA--------------T-------C-------C-C--------CC------CCT");
//			neurites.put("Vn05312006-1-B-Axon","----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A--------------------------------------A-------------------------------T----------------------------------------------------------------------------------------------------C----T-----A--------CTA------------------------C------------------C---------------C-------A----C----T----------A-CT--CT-------------------C-----------------------CA-------------------------------------------------T--------------------C----------------------------------------A--------------------------------T-----A-----------------C-T------------C---------C--C---CT-------------------------------------------------------------------------------------------A------------------------------------------------------------------------------------------------------------------------------------A------------------------------------------------C-------C--CT----------------------------------A------------C------------C--C---C-T--C-----------------C-------C--CC---------C---CC-T----------------------------------------------------------------------------------------------------A--C-------------------------------------------------------C----------------CC-----------------------------------------------C----CA-----------C-----T---------AC-C---CC-CT---A---C-T-C----AC-T-AT-T--------------------------A-------------------------C-------------------A-C----------CCT---------A--T------CC-T------------------------------------A----------------------------------C---C-T------C--CC------------A---------------------A-----------C-CT-------------C------A-T-T--------C----C---------------------------------C------------C---A-----------AT-T-------C---------A-----T---C--------T");
//			neurites.put("TG073axEndLayers-Axon","-----------------------------------------------------------A--------------------------------------C-----------------------------------------------------------C-----------------------------------C--C-------C-T-------------------------C-------------------------------------------------------------------------------------------------------------------------------------A-------------------------------------------------------------------A-----A----T-------T------------------------------------A---T--C---T-----------A---------------------------------A-------------A---------------------T-CA-------------------------------T--------------------A------------------C-----T----------------A---------CT------C---------C--------CA-T-CT----------------A----C-----------------C-C------------------C---------------A----T--A----C---CTC-----CC--A--T-CCT--C--------A---T---A------------------T-----A---------------C-----------------------------C---T--------------------C----------------------------------------A--------------------------------TC----C-------------------------C--CC--A------T-----A-T--T-------------------------------------------------------------------------------------------A------------------------------------------------------------------------------------------------------------------------------------A-----------------------------------------------------------CT----------------------------------A----------------------------------T-------------------------------------------------T---C------------------------------------------------------------------------------------------------A--C-------------------------------------------------------C----------------CA--------------------------------------------T--------A----------CA-T-CCT-C-------A----------T---A---C-T------A--T-C--T------A-----------------T-A-------------------------C-------------------C----------------------C-C---------CATT------------------------------------A----------------------------------C---C-T----------A-----------TA--------------------------------------------------C------C---T-------------C---------------------------------C------------C---A-------------CT-------A------T--A-----T---C------CCT");
//			neurites.put("AM107-4-3-Axon","----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------T----------------A-----------------------------------------------------------C-------C-----------------C--C-----CT--------------------------------------------A---------------C-----------------------------C---T-------------------------------------------------------------C--------------------------------------C--------------------------------C------------C---CT--A-----------------------------------------------------------------------------C---C--T---A------------------------------------------------------------------------------------------------------------------------------------A------------------------------------------C-----C-------C--CT----------------------------------A------------C------------C--C---C-T--------------------C-----------C---------C----C-T----------------------------------------------------------------------------------------------------A----------------------------------------------------------------------------------------------------------------------------------A---CA--CT-CC---CCT-C-------C-------------CC------CC----A--T-C--T--------------------------A-------------------------C-------------------A-------------CT---------A-CT------CC-T------------------------------------C----------------------------------------------------------------A--------------------------------------------------A--T---C---T-------------A-----------------A----T--C-CT----C------------A--TA-----------ATCT-----------------C---------C-------CT");
//			neurites.put("AM60-1-Axon","----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A-------------------C-------------A-------------C------------------------A-----------------------------C-T--------------------------------------------------------------A----------T--------------------------C----T-----C----------A------------------------C------------------C---------------C-------C-----------------C--C---CCCT-------------------C-----------------------CA---------------------------------------------C---T-------------------------------------------------------------C--------------------------------------C--------------------------------C------------C---CT-------------------------------------------------------------------------------------------A------------------------------------------------------------------------------------------------------------------------------------A--C------------------------------C--------C-----C------CC--CT----------------------------------A--------------------------------C-T--------------------C-----------A---T-----C----C-T----------------------------------------------------------------------------------------------------A----------------------------------------------------------------------------C-----------------------------------------------------A-----------C----CT---------C--------------C------------C-------T--------------------------A-------------------------C-------------------A--------------T---------C----------C-T------------------------------------C----------------------------------------------------------------A---------------------C----------------------------C------C--CT-------------AC---------C----C-A---CT--C-CT----C----------C-C---A-----------C-CT-------C-------C-A-----T---A--CT---CT");

//			AATACCCTACTCCCCTACATCCTAACTCATCCTACCCTCACCTATATCCCCT
//
//			------------------A---A---TA--------C---CC---T-------A---C-T-----C--C-----C--C--TAC-------ATC--C-T-----AACTC-AT-C--CT-ACCCTC---ACCTAT--A------TC----CCCT
//			ACCATATCCCCCCCCCCTAACTACCCTAATCCATCCACCTCCCCCTACTACCTAACTCCTCCACTACTATCCCCCCCCCCTAACATATCTC-CATATTACCCTAA-TATC-CACTCTCA--CTATATA-CTATCCACCCCCCTACATTCCCT
			
			String consensusName = "AxonCluster3ForFig5-T50";
			String consensusWithGaps = "-------------------------------------A------------------------A-----------------------------A-------------------------C---------T-------------------------A---------C-T---------------------A----T--------C----C-T----------A--------------------------------------------------------------------T-------------A------------------------------------A--------T-----------------C----C--T------------------------------------A----------------C-----C--T-------------A-----------C-T---C----------C--------A---T-----C-T-------------------------------------------------------------------------------------A---------------------------------A-------------------------------------------A----------C----T------C------A-----T-C-----T-----------------------------------A------------------------A------------T-----C-----C----C-T----------------------A----------------------C-----C-T---------A--------------T-C--------A--------T-C--------C-C-T-----------A-------------------------------------------A-------------------------------------------A------T---C------C----T----------------------------A--------------------------------C-C-T--------------------A---------------T-------------C---C---C--T-------------------------A-----C---------------------------------------------------A-------------------C----T----C---------------A----------C-T-----------C------C--T------------------------------A----------------------------------------A-----------T-----------------A-----T---------C--------CT------------------A--------------------------C------C--T-------------------A----------------------C-----C--T-----------A------C---T--------------A----T--C---C------T";

			outputDir = new File("/home/tgillett/figures/Pasta2/");
			neurites = new TreeMap<String,String>();
			neurites.put("BE12D-Axon","-------------------------------------A------------------------AC--A-----------------T-------A-------------------------C-------C-T--C----------------------A---------ATT---------------------A-AT-T--------A-TCCC-T----------A----AC-AC--T---C--C--CCT----------A--C------T-------C--A----CT----ATT-------------A-------------A-------------------T--A------CCT-----------------C----C--T-A----CT---A-------------------TC-C-A----------------------C--T----CC-------A----C----C-C-TC--A-------CT-C-------CC-----CC--C-T-------------------------------------------------------------------------------------A---------------------------------A--C-----------------------------C----------A---------------T------C------C-------C-----T-----------------------------------A-------------------------------------------C------------T----------------------A----------------------------C-T---------C-------------------------C-----------------------T-----------A-------------------------------------------A-----------------------------------C-------A------T---A---T--C---CT----------------A----C---T--A---------------------------ACCT-C-C-T-------A-----------TA---------------T----A--T----CC--CC---C-CT-------------------------A---------------------------------------------------------A------------A----T-A-T-CT----C---------------A------------T-----------C------C--T------------------------------A----------------------C-----------------A---------C-T-----------------A-----T-------------------T------------------A---------------------------------C--T-------A---TCCC----A-------------------------------T-------C---A----------T---A------T---A--ATT------A--TC--T");
			neurites.put("C180298A-I4-Axon","-------------------------------------A------------------------A---A----CCC----C--C--T---ACCTA--C---------C-------C--CCA---CT--C-T-------------------------A---------C-T--------C-----C-----CA----T----C--CC---CC-T---------------------------------------------------------------------------------------------A---------A-T-A---------------ATC-T--A-------CT-------------A-TCC---CC-CT------------------------------------A----------------AC-T-CATCT-------------A-----------ATT--------------C--------A--CT-----C-T-------------------------------------------------------------------------------------A---------------------------------A-------------------------------------------C----------------------C------A-----T-C-----T-----------------------------------A------------------------A------------T-----A---T--------T----------------------A----------------------------C-T---------A-----------C--T-A--T-C---A--------T-C--------ATC-T-----------A-------C-----A---------------------------T-A-------------------------------------------C----------C------A-T--T----------------------------A--------------------------------C-C-T-------C------------A---------------T----C--------A-T-A-CTATCT-------------------------A-----A-----------------------------------------C---T-----A------------------------T-C--A-----------T---A---C------C-T----C-----CA--T--CATCT------------------------------A----------------------------------------A---A---T-C-T-----------------C-----------C---C------C-CT------------------A--------------------------A----T----T-------A---T-CC----A----------------AC--T-C-----C-CT-----------A------C--CT--------------A--C-T------C------T");

//			neurites.put("C200897C-I1-Axon","-----A--A--T-CATA------CTACC-T-CAT--TA------------------------A-----------------------------A-------------------------C---------T--C---------------------CA-----------T--------------A----T-A-C-CT--------C----C-T----------A----------------------------------A---------T----------C------------T-----C-------A------------------------------------C--------------------------C----C--T------------------------------------A-------------------------T-----C-------A-------------T---C----------A-----T--A--CT-CC--C-T-------------------------------------------------------------------------------------A---------------------------------A--------------------------------C----------C----------------------C------C-------C----CT------A---------------TC--C--------A-------------------------------------------C------------TC---------------------A----------------------C-----C-T---------C----------------C--------A-------CT-C-----C--C-C-T-----------A-------------------------------------------A--------C-------A------------T-----C-------A-C---CT---C------C---CT----------------------------A--------------C------------ACCT-C-C-T--------------------A-----A--CTC-C-CT----A--T-----C--CC---ATCT-------------------------A---------------------------------------------------------A----C-C-----C------A-T--T-C--C---------------A------------TC---C-----CC-----CAT-T------------------------------A----------------------------------------A-----------T---------------C-A-----T-----C---A---CT-C-CT------------------A-----------------C--------C------C-CT-------------------C-------------------------------------------A----------T--------------C-----------A--T---T");
//			neurites.put("BE83F-Axon","-----C-------------------------------A------------------------A-------------------------------------------------------------------------------------------C------------------------------------------------------T---------------------------------------------------------------------------------------------C------------------------------------------------------------------------------------------------------------C---------------------------------------A-------------T--------------C--------C-----------T--------------------A---------C-------------------------------C----------C-------C--TA---------------------------------A-------------------------------------------A----------C----TCC----A----T-A-----TCC---CCT--------------------------A--CAT-T-A---------------------C--A-CA---TACTCCTCCACTAC-CTCA-T--C-T----------------------A--A---CAT--T-CC----C--C---ATC-T---------A-----------C--T-A-CT-----A-CC--C-CT-C-----C--C-C-T-----------A-------------------------------------------A-----------------------------------C-------A-C---CT---A---T--C----T----------------A----A-T-T--A---------------------------C----ATC-T-------C------------A----------C-ATCT----C--------A-T-A--TC-CT-------------------------A-----A-C---------------C------------------C---CC--CT-C---A------------C------A-T--T-C--C---------------C-----------------C------C------C-CT------------------------------A----------------------------------------A-----------T---------------C-C-----------C---C-----CC-CT------------------AC----------------C--------A----T-C--T-------------------A----------------------C-----C--T-----------C-------------------------A----T------C------T");
//			neurites.put("AP041910E-1-Axon","A-T--A-------------------A---T--C-CCTA------------------------A---A----CCA--T-C--AT-T---A--TA--AA-T-CC-T-C------------C-------ATT-------------------------A---------C-T--------------A----T-A-C-CT-------CC---CC-T----------A----A--C--------------CT------C---C-----------C-----C--A----CT--C-C-T-------------A-------------C----------------------A-A--T--CT-------------C---A--T-C--T------------------------------------A---C-----------CA--T--C-CT-------------A---------C-C-T---A-------CT-C--------A--CT--A-TC-T-------------------------------------------------------------------------------------A---------------------------------A-------------------------------------------C-----------------------------C-------C-----T-----------------------------------A------------------------A-----------CT-----AC-CTCA-T--C-T----------------------A-------------------C--A--T--C-T---------A-----------C--T-C----C--CA-------CT-C----------C-T-----------A-------------------------------------------A-------------------------------------------A-C---CT---C------C----T----------------------------A---------------------------C----ATC-T--------------------A---------------T-------------C---C---C--T-A--------------------CT-A-----A-----------------------------------------C---T-----A------------------------T-C--C--------------CC-----------------C------C-----CC-CT------------------------------A--------------------------------------------------------------------------------------C---------T------------------C---------------------------------------------------C----A----------------------------C--T-----------C-------------------------A--C-T------A--T---T");

			for (String neuriteName : neurites.keySet()){
				neuriteAlignment = neurites.get(neuriteName);
				neuronName = StringUtils.getNeuronNameFromSequence(neuriteName);
				swcFile = DataProperties.getInstance().getSwcFileByName(neuronName);
				System.out.println(neuronName+" " +swcFile);
				ungappedSeqs = removeExcessGaps(neuriteAlignment, consensusWithGaps);
				try{
					SwcACTWriter.redrawNeuriteByAlignment(
						swcFile, outputDir, "STL", 
						neuriteName, consensusName, 
						ungappedSeqs[0], ungappedSeqs[1], 1, 
						true, true);
				} catch (Exception e){
					System.out.println("Failed to convert "+neuriteName);
					e.printStackTrace();
				}
	
			}
			
		} catch (Exception e){
			e.printStackTrace();
		}

	}

	private static String[] removeExcessGaps(String seq1, String seq2){
		String[] ungappedSeqs = new String[2];
		ungappedSeqs[0] = "";
		ungappedSeqs[1] = "";
		for (int i = 0; i < seq1.length(); i++){
			if (seq1.charAt(i) != '-' || seq2.charAt(i) != '-'){
				ungappedSeqs[0] += seq1.charAt(i);
				ungappedSeqs[1] += seq2.charAt(i);
			}
		}
		return ungappedSeqs;
	}
	
	private static final String PARAM_INPUT_FILE = "inputFile";
	private static final String PARAM_OUTPUT_DIR = "outputDir";
	private static final String PARAM_ARBOR_TYPE = "arborType";
	private static final String PARAM_BINARY_TREE = "binaryTree";
	private static final String PARAM_LABEL_TYPE = "labelType";
	
	private static JSAPResult readParameters(String[] args) throws Exception{
		JSAP jsap = new JSAP();
		FlaggedOption opt;

    	opt = new FlaggedOption(PARAM_INPUT_FILE)
		.setStringParser(JSAP.STRING_PARSER)
		.setRequired(true) 
		.setShortFlag('i') 
		.setLongFlag(PARAM_INPUT_FILE);
        jsap.registerParameter(opt);

    	opt = new FlaggedOption(PARAM_OUTPUT_DIR)
		.setStringParser(JSAP.STRING_PARSER)
		.setRequired(false)
		.setShortFlag('o') 
		.setLongFlag(PARAM_OUTPUT_DIR);
        jsap.registerParameter(opt);

    	opt = new FlaggedOption(PARAM_ARBOR_TYPE)
		.setStringParser(JSAP.INTEGER_PARSER)
		.setRequired(false)
		.setDefault("0")
		.setShortFlag('a') 
		.setLongFlag(PARAM_ARBOR_TYPE);
    	opt.setHelp("0 - All\n1 - Axon\n2 - Dendrite\n3 - Basal Dendrite\n4 - Apical Dendrite\n");
        jsap.registerParameter(opt);

    	opt = new FlaggedOption(PARAM_LABEL_TYPE)
		.setStringParser(JSAP.STRING_PARSER)
		.setRequired(false)
		.setDefault("None")
		.setShortFlag('L') 
		.setLongFlag(PARAM_LABEL_TYPE);
    	opt.setHelp("NONE\nACT\nNODE_TYPE\nORDER_AND_TYPE\n");
        jsap.registerParameter(opt);
        
        Switch switchOpt = new Switch(PARAM_BINARY_TREE)
		.setShortFlag('b') 
		.setLongFlag(PARAM_BINARY_TREE);
        jsap.registerParameter(switchOpt);

        JSAPResult config = jsap.parse(args);
        if (!config.success()) {
        	for (@SuppressWarnings("rawtypes")
			java.util.Iterator errs = config.getErrorMessageIterator();errs.hasNext();) {
        		System.err.println("Error: " + errs.next());
        	}
            System.err.println();
            System.err.println("Usage: java "
                                + SwcToNewick.class.getName());
            System.err.println("                "
                                + jsap.getUsage());
            System.err.println();
            // show full help as well
            System.err.println(jsap.getHelp());
            System.exit(1);
        }
        return config;
	}

}
