package org.cn3.ns.scripts;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Stack;

import org.cn3.morpho.data.MetaDataManager;
import org.cn3.morpho.data.SwcEditor;
import org.cn3.morpho.data.SwcToNewick;
import org.cn3.morpho.data.SwcToNewick.NewickLabel;
import org.cn3.morpho.domain.BinaryTreeNode;
import org.cn3.morpho.domain.NeuronMetadata;
import org.cn3.morpho.domain.SwcDataNode;
import org.cn3.morpho.domain.SwcTreeNode;
import org.cn3.morpho.utils.BinaryTreeUtils;
import org.cn3.morpho.utils.StringUtils;
import org.cn3.ns.data.DataConverter;
import org.cn3.ns.data.FastaReader;
import org.cn3.ns.data.SwcACTWriter;
import org.cn3.ns.data.SwcACTWriter.NodeLabelOption;
import org.cn3.ns.resources.DataProperties;
import org.cn3.ns.resources.NSConstants;

/**
 * 
 * @author gillette
 * java -classpath .:lib/JSAP-2.1.jar org.cn3.ns.scripts.FigureDataGenerator
 *
 * Used to generate data and files for figures in Gillette, Hosseini, and Ascoli, 2015.
 * It is a hodgepodge, but may be useful.
 *
 */
public class FigureDataGenerator {

	public static void main(String[] args){
		try{
			Map<String,NeuronMetadata> metadata = MetaDataManager.getCellMetaData();
			
			//colorByMultipleKmers(metadata, false);
			colorBySingleKmers(metadata, true);
			//colorAndDiameterSpecial(metadata);
			
			/**
			 *  Convert a sample of surrogates into dendrograms (Newick format)
			 *  with kmer of different type for kmer percentile rank figure
			 */
			/*
			// Set parameters
			neuriteName = "MD070408-ApicalDendrite";
			kmer = "AC";
			kmer2 = "AT";
			dataset = "NM_SpurLen2D";
			order = "STL";
			nodeLabelOption = NodeLabelOption.MONOMER_AND_TYPE;
			newickLabelOption = getNewickLabelOpt(nodeLabelOption);
			
			// Read real neurite sequence
			String fastaFilename = DataProperties.getInstance().getFastaFilename(dataset, NSConstants.MAPPING_MODE_TOPO_ACT, order);
			FastaReader fr = new FastaReader(fastaFilename);
			while (fr.next()){
				if (fr.getSequenceName().equals(neuriteName)){
					break;
				}
			}
			if (fr.isClosed()){
				throw new Exception("Neurite name '"+neuriteName+"' not found in fasta file "+fastaFilename);
			}
			
			tree = DataConverter.fastaACTStringToTree(fr.getSequence());
			fr.close();
			
			// Retype nodes by kmer
			SwcACTWriter.setDataByKmer(tree,order,kmer,nodeLabelOption,5);
			if (!StringUtils.isEmpty(kmer2))
				SwcACTWriter.setDataByKmer(tree,order,kmer2,nodeLabelOption,6,false);

			// Produce dendrogram for real neurite
			if (!StringUtils.isEmpty(kmer2))
				filename = "/home/tgillett/results/NeuriteDendrogram_"+neuriteName+"_"+kmer+"&"+kmer2+"_"+nodeLabelOption+".newick";
			else
				filename = "/home/tgillett/results/NeuriteDendrogram_"+neuriteName+"_"+kmer+"_"+nodeLabelOption+".newick";
			SwcToNewick.createNewickFile(tree, newickLabelOption, new File(filename));
			 */
			/*
			// Read surrogates
			Map<Integer,Map<String,List<String>>> surrogateData =  
				ConstraintsDataReader.loadSurrogates(
					1, dataset, order, 
					NSConstants.DISTRIBUTION_NODE_TYPE_ASSEMBLED3, 40, false);
			System.out.println(surrogateData.keySet());
			List<String> surrogates  = surrogateData.get(k).get(neuriteName);
			
			// Go through surrogates and produce a newick file for each
			int numSurrogates = 6;
			for (int i = 1; i <= numSurrogates; i++){
				// Convert sequence to binary tree
				tree = DataConverter.fastaACTStringToTree(surrogates.get(i-1));
				if (nodeLabelOption == NodeLabelOption.NODE_TYPE){
					SwcDataUtils.insertSwcDataNodes(tree, 2);
				}
				
				// Retype nodes by kmer
				SwcACTWriter.setDataByKmer(tree,order,kmer,nodeLabelOption,5);
				if (!StringUtils.isEmpty(kmer2))
					SwcACTWriter.setDataByKmer(tree,order,kmer2,nodeLabelOption,6,false);

				// Produce dendrogram for select surrogates
				if (StringUtils.isEmpty(kmer2))
					filename = "/home/tgillett/results/SurrogateDendrograms_"+neuriteName+"_"+kmer+"_"+i+"_"+nodeLabelOption+".newick";
				else
					filename = "/home/tgillett/results/SurrogateDendrograms_"+neuriteName+"_"+kmer+"&"+kmer2+"_"+i+"_"+nodeLabelOption+".newick";
				SwcToNewick.createNewickFile(tree, newickLabelOption, new File(filename));
			}
			*/
		} catch (Exception e){
			e.printStackTrace();
		}
	}

	private static void colorAndDiameterSpecial(Map<String,NeuronMetadata> metadata)throws Exception{
		BinaryTreeNode tree, treeCopy;
		String filename;
		NodeLabelOption nodeLabelOption;
		File swcFile;
		int kmerLabel1;
		List<BinaryTreeNode> treeNodes, treeCopyNodes;
//		NewickLabel newickLabelOption;
		
		// Set parameters
		String dataset,order,outputDir,swcDir;
		String arborType,kmer2=null,kmer3=null;
		//String neuronName, kmer;

		dataset = "NM_SpurLen2D";
		order = "STL";
		//outputDir = "/home/tgillett/results/";
		//outputDir = "C:/Documents and Settings/gillette/My Documents/research/papers & presentations/PASTA Paper/Paper1 - Motifs/figures/Components/";
		//swcDir = "C:/swcData/NM/";
		swcDir = "/home/tgillett/swcFiles/NM/";
		outputDir = "/home/tgillett/results/swc/trimerPicks/";
		nodeLabelOption = NodeLabelOption.MONOMER_AND_TYPE;

		/**
		 * Retype given morphology by kmer(s) and create Newick version too. 
		 */
		//neuriteName = "BE71E-Axon";
		//neuronName = "BE71E";
		arborType = "Dendrite";
		// Looking for axons that might have an interesting regional or domain distribution of kmers 
		//String[] neurons = {"Oi27rpy1", "Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "ca1a", "13rs-ax", "27rs-ax", "EC2-609291-4"};
		//String[] neurons = {"Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "13rs-ax", "EC2-609291-4"};
		//String[] neurons = {"C130897B-I1","C271097A-I4","031214000","08-21-00-chandelier","BE25C","BE74C","AM85-2-1","C210301C1","DEV159T2","lawrence-03-04-03-01-3","RLC6cB-7","Oi27rpy1"};
		//String[] kmers = {"C", "AA", "AC", "AT", "CA", "CC", "CT","TA","TC","TT","AAA","AAC","CCA","CCC","CCT","ATC","CAT","CTA","TCC","TCT","ACC","ACT","TCA"};
		
		// Sample of axons with high ACT and low ACC
		//String[] neurons = {"030223-4-PV","Rat-ngf-12-29-04","AKO60sdax2lay","BE43D"};
		//String[] neurites = {"030223-4-PV-Axon","Rat-ngf-12-29-04-Axon","AKO60sdax2lay-Axon","BE43D-Axon"};
		// Sample of dendrites with low ACT and high ACC
		//String[] neurons = {"970213c","JM012804-30","5-S16-4","8-2-3"};
		//String[] neurites = {"970213c-Dendrite","JM012804-30-Dendrite","5-S16-4-BasalDendrite","8-2-3-BasalDendrite"};
		
		String[] neurites = {"030223-4-PV-Axon","Rat-ngf-12-29-04-Axon","AKO60sdax2lay-Axon","BE43D-Axon","970213c-Dendrite","JM012804-30-Dendrite","5-S16-4-BasalDendrite","8-2-3-BasalDendrite"};

		String kmer = "ACT";
		kmerLabel1 = 5;
		int kmerLabel2 = 6;
		kmer2 = "CT";
		float radiusMult = 8;

		
		//for (String neuronName : neurons){
			//String neuriteName = neuronName+"-"+arborType;
		for (String neuriteName : neurites){
			String neuronName = StringUtils.getNeuronNameFromSequence(neuriteName);
			arborType = StringUtils.getArborizationType(neuriteName);
			
			
			// Redraw SWC with retyped nodes
			swcFile = new File(swcDir+metadata.get(neuronName).getArchive().toLowerCase()+"/CNG version/"+neuronName+".CNG.swc");
			System.out.println(swcFile);
			SwcEditor swcEditor = new SwcEditor(swcFile,arborType);
			swcEditor.setUseParentNodeForTerminalType(true);
			treeNodes = BinaryTreeUtils.createBifurcationList(swcEditor.getBinaryTree());

			tree = swcEditor.getBinaryTree();
			SwcACTWriter.setDataByKmer(tree, order, kmer, NodeLabelOption.SWC_NODE_TYPE, kmerLabel1, false);
			if (!StringUtils.isEmpty(kmer2)){
				treeCopy = BinaryTreeUtils.copyTree(swcEditor.getBinaryTree());
				treeCopyNodes = BinaryTreeUtils.createBifurcationList(treeCopy);
				for (int nodeInd = 0; nodeInd < treeCopyNodes.size(); nodeInd++){
					SwcDataNode data = treeNodes.get(nodeInd).getSwcData();
					treeCopyNodes.get(nodeInd).setData(new SwcDataNode(data.getNodeId(), data.getParentId(), data.getType()));
				}

				// Separately type nodes that are part of two different kmers
				SwcACTWriter.setDataByKmer(treeCopy, order, kmer2, NodeLabelOption.SWC_NODE_TYPE, kmerLabel2, false);
				resizeRadiusByBinaryTreeTypes(swcEditor.getSwcTree(), treeCopy, kmerLabel2, radiusMult);

				//System.out.println(treeCopyNodes.size()+" "+treeNodes.size());
				swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+kmer+"-"+kmer2+"-Rx"+radiusMult+".swc", true);
			}else{
				swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+kmer+".swc", true);
			}
		}
	}
	
	private static void resizeRadiusByBinaryTreeTypes(SwcTreeNode tree, BinaryTreeNode binaryTree, int targetType, float radiusMult){
		// Create nodeId->type map for binary tree nodes
		Map<Integer,Integer> binaryNodeTypeMap = new HashMap<Integer,Integer>();
		List<BinaryTreeNode> binaryNodes = BinaryTreeUtils.createNodeList(binaryTree);
		for (BinaryTreeNode node : binaryNodes){
			binaryNodeTypeMap.put(node.getSwcData().getNodeId(), node.getSwcData().getType());
		}

		// Make a nodeId->type map for swc nodes associated with alignment bifurcation nodes
		// First load all terminal nodes
		Stack<SwcTreeNode> swcNodeStack = new Stack<SwcTreeNode>();
		swcNodeStack.addAll(BinaryTreeUtils.createTerminalNodeList(tree));

		/**
		 *  Traverse tree, setting node types
		 */
		
		// Work up from terminal nodes, setting type
		int tailType, headType, nodeCount, currCount, switchCount;
		SwcTreeNode childNode, traversalNode;
		boolean isRootSegment;
		Set<SwcTreeNode> completed = new HashSet<SwcTreeNode>();
		while (!swcNodeStack.isEmpty()){
			childNode = swcNodeStack.pop();

			// Determine type of current (tail) node
			if (binaryNodeTypeMap.containsKey(childNode.getNodeId())){
				tailType = binaryNodeTypeMap.get(childNode.getNodeId());
			}else{
				tailType = -1;
			}

			// Determine type of parent bifurcation node
			nodeCount = 0;
			traversalNode = childNode.getParent();
			while (traversalNode.hasParent() && traversalNode.getChildren().size() == 1){
				nodeCount++;
				traversalNode = traversalNode.getParent();
			}
			isRootSegment = !traversalNode.hasParent();
			headType = binaryNodeTypeMap.containsKey(traversalNode.getNodeId())  
					? binaryNodeTypeMap.get(traversalNode.getNodeId())
					: traversalNode.getType();
			if (tailType == -1 || childNode.isLeaf()){
				tailType = headType;
			}

			// Traverse up again, this time setting the node type based on branch head and tail types
			traversalNode = childNode;
			currCount = 0;
			// If tail is leaf or head and tail are same type, all nodes are the same type, otherwise switch half-way 
			switchCount = childNode.isLeaf() || headType == tailType ? nodeCount+1 : nodeCount/2;
			do{
				if (currCount < switchCount || isRootSegment){
					//swcTypeMap.put(traversalNode.getNodeId(),tailType);
					//traversalNode.setType(tailType);
					if (tailType == targetType){
						traversalNode.setRadius(traversalNode.getRadius()*radiusMult);
					}
				}else{
					//swcTypeMap.put(traversalNode.getNodeId(),headType);
					//traversalNode.setType(headType);
					if (headType == targetType){
						traversalNode.setRadius(traversalNode.getRadius()*radiusMult);
					}
				}
				currCount++;
				traversalNode = traversalNode.getParent();
			}while (traversalNode.getChildren().size() == 1 && traversalNode.hasParent());
			completed.add(childNode);
			
			// Add parent (if parent hasn't already been added)
			if (traversalNode.hasParent() && !completed.contains(traversalNode)){
				swcNodeStack.push(traversalNode);
			}
		}
	}

	private static void colorBySingleKmers(Map<String,NeuronMetadata> metadata, boolean produceDendrograms)throws Exception{
		BinaryTreeNode tree, treeCopy;
		String filename;
		NodeLabelOption nodeLabelOption;
		NewickLabel newickLabelOption;
		File swcFile;
		int kmerLabel1, kmerLabel2, kmerLabel3, kmerLabelMix, kmerLabelMix2;
		List<BinaryTreeNode> treeNodes, treeCopyNodes;
		
		// Set parameters
		String dataset,order,outputDir,swcDir;
		String arborType,kmer2=null,kmer3=null;
		//String neuronName, kmer;

		dataset = "NM_SpurLen2D";
		order = "STL";
		//outputDir = "/home/tgillett/results/";
		//outputDir = "C:/Documents and Settings/gillette/My Documents/research/papers & presentations/PASTA Paper/Paper1 - Motifs/figures/Components/";
		//swcDir = "C:/swcData/NM/";
		swcDir = "/home/tgillett/swcFiles/NM/";
		outputDir = "/home/tgillett/results/swc/trimerPicks/";
		nodeLabelOption = NodeLabelOption.MONOMER_AND_TYPE;
		newickLabelOption = getNewickLabelOpt(nodeLabelOption);

		/**
		 * Retype given morphology by kmer(s) and create Newick version too. 
		 */
		//neuriteName = "BE71E-Axon";
		//neuronName = "BE71E";
		arborType = "Dendrite";
		// Looking for axons that might have an interesting regional or domain distribution of kmers 
		//String[] neurons = {"Oi27rpy1", "Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "ca1a", "13rs-ax", "27rs-ax", "EC2-609291-4"};
		//String[] neurons = {"Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "13rs-ax", "EC2-609291-4"};
		//String[] neurons = {"C130897B-I1","C271097A-I4","031214000","08-21-00-chandelier","BE25C","BE74C","AM85-2-1","C210301C1","DEV159T2","lawrence-03-04-03-01-3","RLC6cB-7","Oi27rpy1"};
		//String[] kmers = {"C", "AA", "AC", "AT", "CA", "CC", "CT","TA","TC","TT","AAA","AAC","CCA","CCC","CCT","ATC","CAT","CTA","TCC","TCT","ACC","ACT","TCA"};
		
		// Sample of axons with high ACT and low ACC
		//String[] neurons = {"030223-4-PV","Rat-ngf-12-29-04","AKO60sdax2lay","BE43D"};
		//String[] neurites = {"030223-4-PV-Axon","Rat-ngf-12-29-04-Axon","AKO60sdax2lay-Axon","BE43D-Axon"};
		// Sample of dendrites with low ACT and high ACC
		//String[] neurons = {"970213c","JM012804-30","5-S16-4","8-2-3"};
		//String[] neurites = {"970213c-Dendrite","JM012804-30-Dendrite","5-S16-4-BasalDendrite","8-2-3-BasalDendrite"};
		//String[] kmers = {"ACT", "ACC"};
		
		// Chosen axons and dendrites with more CT than TT counts
		String[] neurites = {"11707D-63X-Axon","11707D-63X-Dendrite","C190898A-I1-Axon","C190898A-I1-Dendrite"};
		String[] kmers = {"CT","TT"};

		//for (String neuronName : neurons){
			//String neuriteName = neuronName+"-"+arborType;
		for (String neuriteName : neurites){
			String neuronName = StringUtils.getNeuronNameFromSequence(neuriteName);
			arborType = StringUtils.getArborizationType(neuriteName);
			for (String kmer : kmers){
	//			neuronName = "oi28rpy1";
				//String kmer = "AA";
				//kmer2 = "TA";
				//kmer3 = "TA";
				//kmer3 = "";
				kmerLabel1 = 5;
				kmerLabel2 = 6;
				kmerLabel3 = 8;
				kmerLabelMix = 7;
				kmerLabelMix2 = 9;
				/*neuronName = "47-9-4";
				arborType = "BasalDendrite";
				neuriteName = neuronName+"-"+arborType;
				kmer = "TCT";
				kmer2 = "ACC";*/
				
				if (produceDendrograms){
					// Read real neurite sequence
					String fastaFilename = DataProperties.getInstance().getFastaFilename(dataset, NSConstants.MAPPING_MODE_TOPO_ACT, order);
					FastaReader fr = new FastaReader(fastaFilename);
					while (fr.next()){
						if (fr.getSequenceName().equals(neuriteName)){
							break;
						}
					}
					if (fr.isClosed()){
						throw new Exception("Neurite name '"+neuriteName+"' not found in fasta file "+fastaFilename);
					}
					
					tree = DataConverter.fastaACTStringToTree(fr.getSequence());
					fr.close();
					treeCopy = BinaryTreeUtils.copyTree(tree);
					
					// Retype nodes by kmer
					SwcACTWriter.setDataByKmer(tree,order,kmer,nodeLabelOption,kmerLabel1);
					if (!StringUtils.isEmpty(kmer2))
						//SwcACTWriter.setDataByKmer(tree,order,kmer2,nodeLabelOption,kmerLabel2,false);
						SwcACTWriter.setDataByKmer(treeCopy,order,kmer2,nodeLabelOption,kmerLabel2,true);
					
					// Separately type nodes that are part of two different kmers
					treeNodes = BinaryTreeUtils.createBifurcationList(tree);
					treeCopyNodes = BinaryTreeUtils.createBifurcationList(treeCopy);
					for (int i = 0; i < treeNodes.size(); i++){
						//System.out.println(i+" orig: "+treeNodes.get(i).getData());
						//System.out.println(i+" copy: "+treeCopyNodes.get(i).getData());
						String copyLabel = (String)treeCopyNodes.get(i).getData();
						String nodeLabel = (String)treeNodes.get(i).getData();
						if (copyLabel != null && copyLabel.contains("-"+kmerLabel2)){
							if (nodeLabel != null && nodeLabel.contains("-"+kmerLabel1)){
								treeNodes.get(i).setData(nodeLabel.replace(""+kmerLabel1, ""+kmerLabelMix));
							}else{
								treeNodes.get(i).setData(copyLabel);
							}
						}
					}
		
					// Produce dendrogram for real neurite
					if (!StringUtils.isEmpty(kmer2))
						if (!StringUtils.isEmpty(kmer3))
							filename = outputDir+"NeuriteDendrogram_"+neuriteName+"_"+kmer+"-"+kmer2+"-"+kmer3+"_"+nodeLabelOption+".newick";
						else
							filename = outputDir+"NeuriteDendrogram_"+neuriteName+"_"+kmer+"-"+kmer2+"_"+nodeLabelOption+".newick";
					else
						filename = outputDir+"NeuriteDendrogram_"+neuriteName+"_"+kmer+"_"+nodeLabelOption+".newick";
					SwcToNewick.createNewickFile(tree, newickLabelOption, new File(filename));
					System.out.println("Wrote dendrogram to "+filename);
				}
				
				// Redraw SWC with retyped nodes
				swcFile = new File(swcDir+metadata.get(neuronName).getArchive().toLowerCase()+"/CNG version/"+neuronName+".CNG.swc");
				System.out.println(swcFile);
				SwcEditor swcEditor = new SwcEditor(swcFile,arborType);
				swcEditor.setUseParentNodeForTerminalType(true);
	
				tree = swcEditor.getBinaryTree();
				SwcACTWriter.setDataByKmer(tree, order, kmer, NodeLabelOption.SWC_NODE_TYPE, kmerLabel1, false);
				if (!StringUtils.isEmpty(kmer2)){
					treeCopy = BinaryTreeUtils.copyTree(swcEditor.getBinaryTree());
					treeCopyNodes = BinaryTreeUtils.createBifurcationList(treeCopy);
					for (BinaryTreeNode copyNode : treeCopyNodes){
						copyNode.setData(new SwcDataNode());
					}
					// Separately type nodes that are part of two different kmers
					SwcACTWriter.setDataByKmer(treeCopy, order, kmer2, NodeLabelOption.SWC_NODE_TYPE, kmerLabel2, false);
					treeNodes = BinaryTreeUtils.createBifurcationList(tree);
					//System.out.println(treeCopyNodes.size()+" "+treeNodes.size());
					for (int i = 0; i < treeNodes.size(); i++){
						int copyType = treeCopyNodes.get(i).getSwcData().getType();
						int nodeType = treeNodes.get(i).getSwcData().getType();
						if (copyType == kmerLabel2){
							if (nodeType == kmerLabel1){
								treeNodes.get(i).getSwcData().setType(kmerLabelMix);
							}else{
								treeNodes.get(i).getSwcData().setType(copyType);
							}
						}
					}
					if (!StringUtils.isEmpty(kmer3)){
						treeCopy = BinaryTreeUtils.copyTree(swcEditor.getBinaryTree());
						treeCopyNodes = BinaryTreeUtils.createBifurcationList(treeCopy);
						for (BinaryTreeNode copyNode : treeCopyNodes){
							copyNode.setData(new SwcDataNode());
						}
						// Separately type nodes that are part of two different kmers
						SwcACTWriter.setDataByKmer(treeCopy, order, kmer3, NodeLabelOption.SWC_NODE_TYPE, kmerLabel3, false);
						treeNodes = BinaryTreeUtils.createBifurcationList(tree);
						//System.out.println(treeCopyNodes.size()+" "+treeNodes.size());
						for (int i = 0; i < treeNodes.size(); i++){
							int copyType = treeCopyNodes.get(i).getSwcData().getType();
							int nodeType = treeNodes.get(i).getSwcData().getType();
							if (copyType == kmerLabel3){
								if (nodeType == kmerLabel1){
									treeNodes.get(i).getSwcData().setType(kmerLabelMix);
								}else if (nodeType == kmerLabel2){
									treeNodes.get(i).getSwcData().setType(kmerLabelMix2);
								}else{
									treeNodes.get(i).getSwcData().setType(copyType);
								}
							}
						}
						
						swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+kmer+"-"+kmer2+"-"+kmer3+".swc", true);	
					}else{
						swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+kmer+"-"+kmer2+".swc", true);
					}
				}else{
					swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+kmer+".swc", true);
				}
			}
		}
	}
	
	private static void colorByMultipleKmers(Map<String,NeuronMetadata> metadata, boolean produceDendrograms) throws Exception{
		BinaryTreeNode tree, treeCopy;
		String filename;
		NodeLabelOption nodeLabelOption;
		NewickLabel newickLabelOption;
		File swcFile;
		int kmerLabel1, kmerLabel2, kmerLabel3, kmerLabelMix, kmerLabelMix2;
		List<BinaryTreeNode> treeNodes, treeCopyNodes;
		
		// Set parameters
		String dataset,order,outputDir,swcDir;
		String arborType,neuriteName,kmer2=null,kmer3=null;
		//String neuronName, kmer;

		/**
		 * Retype given morphology by kmer(s) and create Newick version too. 
		 */
		//neuriteName = "BE71E-Axon";
		//neuronName = "BE71E";
		arborType = "Axon";
		//String[] neurons = {"Oi27rpy1", "Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "ca1a", "13rs-ax", "27rs-ax", "EC2-609291-4"};
		//String[] neurons = {"Oi27rpy2", "oi28rpy1", "980804axden", "entho", "ca1b", "13rs-ax", "EC2-609291-4"};
		String[] neurons = {"C130897B-I1","C271097A-I4","031214000","08-21-00-chandelier","BE25C","BE74C","AM85-2-1","C210301C1","DEV159T2","lawrence-03-04-03-01-3","RLC6cB-7","Oi27rpy1"};
		int[] labels = {5,6,7};
		int label;
		String[][] kmerLists = {
				{"TCA","TCC","ACT"},
				{"TCT","ACC"}};
		String[] kmerList;
		dataset = "NM_SpurLen2D";
		order = "STL";
		outputDir = "/home/tgillett/results/swc/";
		swcDir = "/home/tgillett/swcFiles/NM/";
		String setName = "MotifsVsAntimotifTrimers";
		nodeLabelOption = NodeLabelOption.MONOMER_AND_TYPE;
		newickLabelOption = getNewickLabelOpt(nodeLabelOption);

		//String[] kmers = {"T", "A"};
		for (String neuronName : neurons){
			neuriteName = neuronName+"-"+arborType;
			swcFile = new File(swcDir+metadata.get(neuronName).getArchive().toLowerCase()+"/CNG version/"+neuronName+".CNG.swc");
			System.out.println(swcFile);
			SwcEditor swcEditor = new SwcEditor(swcFile,arborType);
			swcEditor.setUseParentNodeForTerminalType(true);
			tree = swcEditor.getBinaryTree();
			treeNodes = BinaryTreeUtils.createBifurcationList(tree);

			
			for (int setNum = 0; setNum < kmerLists.length; setNum++){
				kmerList = kmerLists[setNum];
				label = labels[setNum];

				// Copy tree data to avoid overwriting previous kmer labels
				treeCopy = BinaryTreeUtils.copyTree(swcEditor.getBinaryTree());
				treeCopyNodes = BinaryTreeUtils.createBifurcationList(treeCopy);
				for (int nodeInd = 0; nodeInd < treeCopyNodes.size(); nodeInd++){
				//for (BinaryTreeNode copyNode : treeCopyNodes){
					SwcDataNode data = treeNodes.get(nodeInd).getSwcData();
					treeCopyNodes.get(nodeInd).setData(new SwcDataNode(data.getNodeId(), data.getParentId(), data.getType()));
				}

				for (String kmer : kmerList){
					// Redraw SWC with retyped nodes
					SwcACTWriter.setDataByKmer(treeCopy, order, kmer, NodeLabelOption.SWC_NODE_TYPE, label, false);
				}

				// Merge current kmer set labels with previous set(s)
				//System.out.println(treeCopyNodes.size()+" "+treeNodes.size());
				for (int i = 0; i < treeNodes.size(); i++){
					int copyType = treeCopyNodes.get(i).getSwcData().getType();
					int nodeType = treeNodes.get(i).getSwcData().getType();
					// Set current node to copy type, to be overridden with other label or mixed type label if other label has been applied
					treeNodes.get(i).getSwcData().setType(copyType);
					int mixLabelInd = 0;
					for (int labelInd = 0; labelInd < setNum; labelInd++){
						mixLabelInd += kmerLists.length-labelInd;
						// If this node has been labeled by this particular earlier label
						if (nodeType == labels[labelInd]){
							// If this node also has been labeled by the current label, set mixed label
							if (copyType == label){
								treeNodes.get(i).getSwcData().setType(labels[mixLabelInd]);
							}else{ // Otherwise set as earlier label
								treeNodes.get(i).getSwcData().setType(nodeType);
							}
							break;
						}
					}
				}
			}
			swcEditor.writeSwc(outputDir+"/"+neuronName+"-"+arborType+"_"+order+"_"+setName+".swc", true);
		}
	}
	
	private static NewickLabel getNewickLabelOpt(NodeLabelOption nodeLabelOpt){
		switch (nodeLabelOpt){
		case SWC_NODE_TYPE:
			return(NewickLabel.NODE_TYPE);
		case KMER:
		case MONOMER:
		case MONOMER_AND_TYPE:
		default:
			return(NewickLabel.DATA);
		}
	}
}
